//
//  HwConstants.h
//  HwRtcEngine
//
//  Created by zhanganl on 2020/3/4.
//  Copyright © 2020 zhang. All rights reserved.
//

#import <Foundation/Foundation.h>

NS_ASSUME_NONNULL_BEGIN

typedef NS_ENUM(NSInteger,HwRtcErrorCode) {
    /*SDK内部错误*/
    HwRtcErrorCodeSdkInternalError = 90000001,
    /**/
    HwRtcErrorCodeMsgToolarge,
    /*内存不足*/
    HwRtcErrorCodeMemNotEnough,
    /*同步信息错误*/
    HwRtcErrorCodeSynsendMsgError,
    /*参数错误*/
    HwRtcErrorCodeParamError,
    /*api呼叫顺序错误*/
    HwRtcErrorCodeApiCalledInWrongOrder,
    /*设置本地视图失败*/
    HwRtcErrorCodeSetupLocalViewFail,
    /*设置远端视图失败*/
    HwRtcErrorCodeSetupRemoteViewFail,
    /*设置设备错误*/
    HwRtcErrorCodeSetDeviceFail,
    /*流处理类型不匹配*/
    HwRtcErrorCodeStreamTreamTypeNotmatch,
    /*初始化中*/
    HwRtcErrorCodeInitializing,
    /*去初始化中*/
    HwRtcErrorCodeUnInitializing,
    /*正在日志上传中*/
    HwRtcErrorCodeLogUploading,
    /*媒体端口错误*/
    HwRtcErrorCodeMediaPortError,
    /*观看视图过多*/
    HwRtcErrorCodeWatchViewTooMuch,
    /**/
    HwRtcErrorCodeMediaCmpErr,
    /*房间状态忙*/
    HwRtcErrorCodeRoomStatusBusy,
    /*服务器无响应*/
    HwRtcErrorCodeServerNoResponse,
    /*切换角色失败*/
    HwrtcErrorCodeUserRoleChangeFail,
    /*加入房间失败*/
    hwrtcErrorCodeJoinRoomFail,
    /*加入房间用户已登录*/
    hwrtcErrorCodejoinRoomUserHasLogined,
    /*加入房间服务器错误*/
    hwrtcErrorCodejoinRoomServerError,
    /*加入房间服务器无法访问*/
    hwrtcErrorCodejoinRoomServiceUnreachable,
    /*加入房间验证错误*/
    hwrtcErrorCodejoinRoomAuthFail,
    /*加入房间验证重试*/
    hwrtcErrorCodejoinRoomAuthRetry,
    /*加入房间时间同步*/
    hwrtcErrorCodejoinRoomClockSync,
    /*加入房间网址不正确*/
    hwrtcErrorCodejoinRoomUrlNotRight,
    /*被踢*/
    hwrtcErrorCodeKickOff,
    /*置于最后*/
    HwRtcErrorCodeButt
};

typedef NS_ENUM(NSInteger,HwRtcLogLevel) {
    /*输出ERROR级别日志*/
    HwRtcLogLevelError = 0,
    /*输出WARNING级别日志*/
    HwRtcLogLevelWarning,
    /*输出INFO级别日志*/
    HwRtcLogLevelInfo,
    /*输出DEBUG级别日志*/
    HwRtcLogLevelDebug
};

typedef NS_ENUM(NSInteger,HwRtcRole) {
    /*双向流角色，例如主播加入*/
    HwRtcRoleJoiner = 0,
    /*发布流角色，例如广播,无法在房间中切换为改角色*/
    HwRtcRolePublisher,
    /*接收流角色，例如观众*/
    HwRtcRolePlayer
};

typedef NS_ENUM(NSInteger,HwRtcMediaType){
    /*音频流*/
    HwRtcMediaTypeAudio = 0,
    /*视频流*/
    HwRtcMediaTypeVideo,
    /*数据流*/
    HwRtcMediaTypeData
};

typedef NS_ENUM(NSInteger,HwRtcVideoDisplayMode) {
    /*黑边模式，通过扩边的方式保持宽高比(不拉伸)*/
    HwRtcVideoDisplayModePad = 0,
    /*裁剪模式，通过裁剪的方式保持宽高比(不拉伸)*/
    HwRtcVideoDisplayModeCrop,
    /*(iOS only)自适应模式,显示图像和设备的横竖屏不同使用黑边模式,横竖屏相同使用裁剪模式*/
    HwRtcVideoDisplayModeAdapt
};

typedef NS_ENUM(NSInteger,HwRtcStreamType) {
    HwRtcStreamTypeSD,   // 标清 180
    HwRtcStreamTypeHD,   // 高清 360-270
    HwRtcStreamTypeFHD,   // 超高清 720-450
    HwRtcStreamTypeLD,   // 流畅 90
    HwRtcStreamTypeBUTT,
};

typedef NS_ENUM(NSInteger,HwRtcEncodeStreamType) {
    HwRtcEncodeStreamTypeLD  = 1,   // 流畅 90
    HwRtcEncodeStreamTypeSD  = 2,   // 标清 180
    HwRtcEncodeStreamTypeHD  = 4,   // 高清 360-270
    HwRtcEncodeStreamTypeFHD = 8,   // 超高清 720-450
};

typedef NS_ENUM(NSInteger,HwRtcSpeakerModel) {
    /*听筒模式*/
    HwRtcSpeakerModelEarpiece,
    /*扬声器模式*/
    HwRtcSpeakerModelSpeaker
};

typedef NS_ENUM(NSInteger,HwRtcDeviceType){
    /*音频播放设备*/
    HwRtcDeviceTypePlayback,
    /*音频录制设备*/
    HwRtcDeviceTypeRecording,
    /*视频采集设备*/
    HwRtcDeviceTypeVideoCapture
};

typedef NS_ENUM(NSInteger,HwRtcDeviceState){
    /*设备状态活跃的*/
    HwRtcDeviceStateActicve,
    /*设备状态残疾的*/
    HwRtcDeviceStateDisabled,
    /*设备状态断开的*/
    HwRtcDeviceStateUnplugged
};

typedef NS_ENUM(NSInteger,HwRtcConnChangeReason) {
    /*正在连接*/
    HwRtcConnChangeReasonConnecting = 0,
    /*加入房间成功*/
    HwRtcConnChangeReasonJoinSuccess,
    /*重连中*/
    HwRtcConnChangeReasonReconnecting,
    /*重连成功*/
    HwRtcConnChangeReasonReconnectSuccess,
    /*加入房间失败*/
    HwRtcConnChangeReasonJoinFailed,
    /*重连失败*/
    HwRtcConnChangeReasonReconncetFailed,
    /*连接中断*/
    HwRtcConnChangeReasonInterrupted,
    /*访问被拒403*/
    HwRtcConnChangeReasonBannedByServer,
    /*心跳超时*/
    HwRtcConnChangeReasonKeepAliveTimeout,
    /*主动离开房间*/
    HwRtcConnChangeReasonLeaveRoom,
    /*服务器异常*/
    HwRtcConnChangeReasonJoinServerError,
    /*sfu服务故障*/
    HwRtcConnChangeReasonSFUBBreakdown,
    /*用户已经登录*/
    HwRtcConnChangeReasonUserHasLogined,
    /*会话过期*/
    HwRtcConnChangeReasonSessioinExpired,
    /*鉴权失败,appid或者签名错误*/
    HwRtcConnChangeReasonAuthFailed,
    /*服务不可达503*/
    HwRtcConnChangeReasonServiceUnreachable,
    /*鉴权重试*/
    HwRtcConnChangeReasonAuthRetry,
    /*URL错误400*/
    HwRtcConnChangeReasonUrlNotRight,
    /*时钟同步*/
    HwRtcConnChangeReasonAuthClockSync,
    /*内部错误*/
    HwRtcConnChangeReasonInternalError,
    /*被踢*/
    HwRtcConnChangeReasonKickOff,
};

typedef NS_ENUM(NSInteger,HwRtcConnStateType) {
    /*连接断开*/
    HwRtcConnStateTypeDisconnected = 0,
    /*建立网络连接中*/
    HwRtcConnStateTypeConnecting,
    /*网络连接成功*/
    HwRtcConnStateTypeConnected,
    /*重新建立网络连接中*/
    HwRtcConnStateTypeReconnecting,
    /*网络连接失败*/
    HwRtcConnStateTypeFailed
};

typedef NS_ENUM(NSInteger,HwRtcAudioRoute) {
    /*扬声器*/
    HwRtcAudioRouteSpeaker = 0,
    /*蓝牙*/
    HwRtcAudioRouteBluetooth,
    /*听筒*/
    HwRtcAudioRouteReceiver,
    /*耳机*/
    HwRtcAudioRouteHeadset,
};

@interface HwConstants : NSObject

@end

NS_ASSUME_NONNULL_END
