//
//  HWDevicesView.h
//  OpenLive
//
//  Created by weshow on 2020/3/18.
//  Copyright © 2020 Agora.io. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "HwRtcEngine.h"
NS_ASSUME_NONNULL_BEGIN

@protocol HWDevicesViewDelegate <NSObject>

- (void)devicesViewSelectVideoDeviceID:(NSString *)videoDeviceID;
- (void)devicesViewSelectPlaybackDeviceID:(NSString *)playbackDeviceID;
- (void)devicesViewSelectRecordingDeviceID:(NSString *)recordingDeviceID;
- (void)devicesViewChangePlayBackDeviceVolume:(int)volume;
- (void)devicesViewChangeRecordingDeviceVolume:(int)volume;

@end


@interface HWDevicesView : NSView
@property (nonatomic, weak) id<HWDevicesViewDelegate>delegate;
@property (nonatomic, assign) BOOL isFirst;///第一打开
- (void)reloadVideoDevice:(NSArray *)videoDevices;
- (void)reloadPlayBackDevice:(NSArray *)playBackDevices;
- (void)reloadRecordingDevice:(NSArray *)recordingDevices;
- (void)setCurrenVideoDevice:(NSString *)device;
- (void)setcurrenPlaybackDevice:(NSString *)device;
- (void)setcurrenRecordingDevice:(NSString *)device;
@end

NS_ASSUME_NONNULL_END
