//
//  HWRoleListView.h
//  OpenLive
//
//  Created by weshow on 2020/3/10.
//  Copyright © 2020 Agora.io. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "HwRtcEngine.h"
#import "HWVideoSession.h"
#import "HWReusePool.h"
NS_ASSUME_NONNULL_BEGIN

typedef void(^HWRoleListViewSelectBlock)(HWVideoSession * _Nullable videoSession);
@interface HWRoleListView : NSView
@property (nonatomic, strong) NSMutableArray *viewsArray;
/// 当前显示个数
@property (nonatomic, assign) NSInteger showingCount;
@property (nonatomic, strong) HwRtcEngine *rtcEngine;
@property (nonatomic, copy) HWRoleListViewSelectBlock selectBlock;
@property (nonatomic, assign) HwRtcRole roleType;
///重用池
@property (nonatomic, strong) HWReusePool *reusePool;
@end

NS_ASSUME_NONNULL_END
