//
//  HWTableRowView.m
//  OpenLive
//
//  Created by weshow on 2020/3/10.
//  Copyright © 2020 Agora.io. All rights reserved.
//

#import "HWTableCellView.h"

@implementation HWTableCellView

- (instancetype)init
{
    self = [super init];
    if (self) {
        [self addSubview:self.iconImageView];
        [self addSubview:self.usernameTextField];
        self.isMuteLocalVideo = NO;
    }
    return self;
}


- (void)drawRect:(NSRect)dirtyRect {
    [super drawRect:dirtyRect];

}

-(void)mouseDown:(NSEvent *)event
{
    if (self.delegate && [self.delegate respondsToSelector:@selector(tableCellViewSelectWithIndex:)]) {
        [self.delegate tableCellViewSelectWithIndex:self.index];
    }
}

- (NSImageView *)iconImageView
{
    if (!_iconImageView) {
        _iconImageView = [[NSImageView alloc] initWithFrame:NSRectFromCGRect(CGRectMake(0, 0, 24, 24))];
    }
    return _iconImageView;
}

- (NSTextField *)usernameTextField
{
    if (!_usernameTextField) {
        _usernameTextField = [[NSTextField alloc] initWithFrame:NSRectFromCGRect(CGRectMake(CGRectGetMaxX(self.iconImageView.frame) + 8, 6, 200-40, 18))];
        _usernameTextField.editable = NO;
        _usernameTextField.bordered = NO;
    }
    return _usernameTextField;
}

- (void)setIsMuteLocalVideo:(BOOL)isMuteLocalVideo
{
    if (isMuteLocalVideo) {
        self.iconImageView.image = [NSImage imageNamed:@"video_cancel"];
    } else {
        self.iconImageView.image = [NSImage imageNamed:@"video_open"];
    }
}

@end
