//
//  HwObject.h
//  HwRtcEngine
//
//  Created by zhanganl on 2020/3/4.
//  Copyright © 2020 zhang. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "HwConstants.h"
#if TARGET_OS_IPHONE
#import <UIKit/UIKit.h>
#elif TARGET_OS_MAC
#import <AppKit/AppKit.h>
#endif
NS_ASSUME_NONNULL_BEGIN

/**
 视频画布对象的属性。
 */
#if TARGET_OS_IPHONE
__attribute__((visibility("default"))) @interface HwRtcView: UIView
@end
#elif TARGET_OS_MAC
__attribute__((visibility("default"))) @interface HwRtcView: NSOpenGLView
@end
#endif

/**
 视频画布对象的属性。
 */
__attribute__((visibility("default"))) @interface HwRtcVideoCanvas : NSObject

/**
 视频显示视图。
 */
@property (strong, nonatomic) HwRtcView* _Nullable view;

/**
 视图的用户标识。
 */
@property (assign, nonatomic) NSString *uid;
@end

__attribute__((visibility("default"))) @interface HwRtcUserInfo : NSObject
@property (strong, nonatomic) NSString* userId;
@property (strong, nonatomic) NSString* userName;
@property (strong, nonatomic) NSString* signature;
@property (assign, nonatomic) long long ctime;
@property (strong, nonatomic) NSString* optionInfo;
@property (assign, nonatomic) HwRtcRole role;
@end

__attribute__((visibility("default"))) @interface HwRtcDeviceInfo : NSObject
@property (strong, nonatomic) NSString* deviceName;
@property (strong, nonatomic) NSString* deviceId;
@end

__attribute__((visibility("default"))) @interface HwRtcVideoEncode: NSObject
/*编码流类型 枚举值HwRtcEncodeStreamType,可以用|表示,默认为6表示(标清+高清),表示支持2路流发送.
 HwRtcEncodeStreamType中4种流可以随意组合.Macz最多支持发送4路流,iOS最多支持发送3路流.
 */
@property (assign, nonatomic) HwRtcEncodeStreamType streamFlag;
@property (assign, nonatomic) int videoBitrate; //总带宽 默认1096
- (instancetype)initWithStreamFlag:(HwRtcEncodeStreamType)streamFlag videoBitrate:(int)videoBitrate;
@end

__attribute__((visibility("default"))) @interface HwRtcVideoStatsInfo: NSObject
@property (strong, nonatomic) NSString *userId;
@property (strong, nonatomic) NSString *codecName;
@property (assign, nonatomic) int width;
@property (assign, nonatomic) int height;
@property (assign, nonatomic) int bitRate;
@property (assign, nonatomic) int frameRate;
@property (assign, nonatomic) int packetLoss;
@property (assign, nonatomic) int delay;
@property (assign, nonatomic) int jitter;
//@property (assign, nonatomic) int packetLoss;
@end

__attribute__((visibility("default"))) @interface HwRtcAudioStatsInfo: NSObject
@property (strong, nonatomic) NSString *userId;
@property (strong, nonatomic) NSString *codecName;
@property (assign, nonatomic) int sampleRate;
@property (assign, nonatomic) int channels;
/// 远端音频才有
@property (assign, nonatomic) int recvVEL;
/// 本地音频才有
@property (assign, nonatomic) int sendVEL;
@property (assign, nonatomic) int bitRate;
@property (assign, nonatomic) int packetLoss;
@property (assign, nonatomic) int delay;
@property (assign, nonatomic) int jitter;
@property (assign, nonatomic) long long bytes;
@end

@interface HwObject : NSObject

@end

NS_ASSUME_NONNULL_END
