//
//  SettingViewController.m
//  OpenLive
//
//  Created by yangmoumou on 2018/2/8.
//  Copyright © 2018年 yangmoumou. All rights reserved.
//

#import "SettingsViewController.h"
#import "MainViewController.h"
#import "HLMonitor.h"
@interface SettingsViewController ()<NSTextFieldDelegate,HwRtcEngineDelegate>
@property (weak) IBOutlet NSTextField *addressTextField;
@property (weak) IBOutlet NSButton *uploadLogButton;
@end

@implementation SettingsViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    _rtcEngine.delegate = self;
    self.addressTextField.stringValue = self.address;
    self.addressTextField.delegate = self;

}

- (IBAction)doConfirmClicked:(NSButton *)sender {
    if ([self.delegate respondsToSelector:@selector(settingsVC:address:)]) {
        [self.delegate settingsVC:self address:self.address];
    }
}
- (IBAction)uploadLogAction:(NSButton *)sender {
    [self.rtcEngine logUpload];
    sender.title = @"上传中...";
}

- (void)controlTextDidChange:(NSNotification *)obj
{
    self.address = self.addressTextField.stringValue;
}

- (void)rtcEngineLogUploadResultCallback:(int)result
{
    dispatch_async(dispatch_get_main_queue(), ^{
        if (result==0) {
            [HLMonitor showMessageWithStr:@"上传成功"];
        } else
        {
            [HLMonitor showMessageWithStr:@"上传失败"];
        }
        self.uploadLogButton.title = @"uploadLog";
    });
}

-(void)rtcEngineLogUploadProgressCallback:(int)progress
{
    dispatch_async(dispatch_get_main_queue(), ^{
        self.uploadLogButton.title = [NSString stringWithFormat:@"上传进度:%d％",progress];
    });
}


@end

