
#ifndef __HW_RTC_INTERFACE_H__
#define __HW_RTC_INTERFACE_H__

#include "rtc_def.h"

#ifdef __cplusplus
#if __cplusplus
extern "C" {
#endif /*  __cpluscplus */
#endif /*  __cpluscplus */


RTC_API int HW_RTC_Init(const char *domain, const char *appId, RtcNotifyFunc notifyFun);

RTC_API int HW_RTC_UnInit(void);

RTC_API int HW_RTC_SetLogParam(RtcLogLevel logLevel, const char *logPath);

RTC_API int HW_RTC_JoinRoom(const RtcJoinRoomInfo *joinRoomInfo);

RTC_API int HW_RTC_SetupLocalView(const RtcVideoLocalView *viewInfo);

RTC_API int HW_RTC_SetupRemoteView(const RtcVideoRemoteView *viewInfo);

RTC_API int HW_RTC_LeaveRoom(void);

RTC_API int HW_RTC_SwitchCamera(const RtcRotationParam *rotationParam);

RTC_API int HW_RTC_SetSpeakerModel(RtcSpeakerModel speakerModel);

RTC_API int HW_RTC_GetRemoteViewFromUserId(const char *userId, RTC_UINTPTR_T *render);

RTC_API int HW_RTC_MuteLocalVideo(unsigned int mute);

RTC_API int HW_RTC_GetPlaybackDevices(unsigned int *num, RtcDeviceInfo *deviceinfo);

RTC_API int HW_RTC_GetRecordingDevices(unsigned int *num, RtcDeviceInfo *deviceinfo);

RTC_API int HW_RTC_GetVideoDevices(unsigned int *num, RtcDeviceInfo *deviceinfo);

RTC_API int HW_RTC_SetPlaybackDevice(const char* deviceId);

RTC_API int HW_RTC_SetRecordingDevice(char* deviceId);

RTC_API int HW_RTC_SetVideoDevice(char* deviceId);

RTC_API int HW_RTC_SetPlaybackDevicesVolume(unsigned int volume);

RTC_API int HW_RTC_GetPlaybackDevicesVolume(unsigned int* volume);

RTC_API int HW_RTC_SetRecordingDevicesVolume(unsigned int volume);

RTC_API int HW_RTC_GetRecordingDevicesVolume(unsigned int* volume);

RTC_API int HW_RTC_MuteRemoteAudio(unsigned int mute);

RTC_API int HW_RTC_MuteLocalAudio(unsigned int mute);

RTC_API int HW_RTC_GetRemoteAudioMute(unsigned int* mute);

RTC_API int HW_RTC_GetLocalAudioMute(unsigned int* mute);

#ifdef __cplusplus
#if __cplusplus
}
#endif /*  __cpluscplus */
#endif /*  __cpluscplus */

#endif /*__HW_RTC_INTERFACE_H__*/

